org.apache.myfaces.trinidad.menu

## Class ImmutableGroupNode

- java.lang.Object
- - org.apache.myfaces.trinidad.menu.MenuNode
  - - org.apache.myfaces.trinidad.menu.GroupNode
    - - org.apache.myfaces.trinidad.menu.ImmutableGroupNode

-     public class ImmutableGroupNode
      extends GroupNode

  This class is a thread safe version of GroupNode class. It replicates most of the code in GroupNode but makes sure it does not modify state of the object. Therefore multiple request threads can access the properties of the objects of this class,in a thread safe manner. Please note that setters should not be called on objects of this class.Objects of this class are fully initialized on construction.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ImmutableGroupNode(GroupNode node)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `char` | `getAccessKey()` getAccessKey - get the label's accessKey as a char.
    `String` | `getBundleKey()`
    `String` | `getBundleName()`
    `List<MenuNode>` | `getChildren()` Get the List of menu item's children.
    `boolean` | `getDefaultFocusPath()` Gets the defaultFocusPath attribute of the menu item.
    `boolean` | `getDisabled()` Gets the disabled attribute of the menu item.
    `String` | `getFocusViewId()` Gets the value of the node's focusViewId property.
    `protected String` | `getHandlerId()` Set the MenuContentHandlerImpl's id.
    `String` | `getIcon()` Get the icon used by the menu item This could either be a string value set directly in the metadata or an EL expression string.
    `String` | `getId()` getId - gets the metadata id of the node.
    `String` | `getIdRef()` Get the id of the node referred to by the idref attribute of this node.
    `String` | `getLabel()` Get the menu item's label This could either be a string value set directly in the metadata or an EL expression string.
    `String` | `getLabelAndAccessKey()` getLabelAndAccessKey - get the label and accessKey together in a single string.
    `String` | `getModelId()` Gets the local (shared node's) menu Model's Request map key.
    `boolean` | `getReadOnly()` Gets the readOnly state of the node.
    `MenuNode` | `getRefNode()` Get the node whose id matches this node's idref attribute value.
    `boolean` | `getRendered()` Gets the rendered attribute of the menu item.
    `int` | `getRootId()`
    `String` | `getRootModelKey()` Get the top-level, root menu model Request Map Key.
    `String` | `getUniqueId()` getUniqueId - gets the unique id of the node.
    `boolean` | `getVisible()` Gets the visible attribute of the menu item.
    `void` | `setChildren(List<MenuNode> children)` Set the List of menu item's children.

    - ### Methods inherited from class org.apache.myfaces.trinidad.menu.GroupNode

      `doAction, getDestination, getIdRefListProperty, getThreadSafeCopy, setIdRef`

    - ### Methods inherited from class org.apache.myfaces.trinidad.menu.MenuNode

      `getAccessKeyProperty, getBundleKeyProperty, getBundleNameProperty, getChildrenProperty, getDefaultFocusPathProperty, getDisabledProperty, getFocusViewIdProperty, getHandlerIdProperty, getIconProperty, getIdProperty, getLabelAndAccessKeyProperty, getLabelProperty, getModelIdProperty, getReadOnlyProperty, getRenderedProperty, getRootIdProperty, getRootModel, getRootModelKeyProperty, getUniqueIdProperty, getVisibleProperty, postSelectedNode, setAccessKey, setAccessKey, setDefaultFocusPath, setDefaultFocusPath, setDisabled, setDisabled, setFocusViewId, setHandlerId, setIcon, setId, setLabel, setLabelAndAccessKey, setModelId, setReadOnly, setReadOnly, setRendered, setRendered, setResBundleKey, setResBundleName, setRootId, setRootModelKey, setVisible, setVisible`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ImmutableGroupNode

          public ImmutableGroupNode(GroupNode node)

  - ### Method Detail

    - #### getIdRef

          public String getIdRef()

      Description copied from class: `GroupNode`
      Get the id of the node referred to by the idref attribute of this node.
      Overrides:
        `getIdRef` in class `GroupNode`
      Returns:
        String id of the node referred to by the idref attribure of this node.

    - #### getRefNode

          public MenuNode getRefNode()

      Description copied from class: `GroupNode`
      Get the node whose id matches this node's idref attribute value.
      Overrides:
        `getRefNode` in class `GroupNode`
      Returns:
        the MenuNode whose id matches this node's idref attribute value.

    - #### getLabel

          public final String getLabel()

      Description copied from class: `MenuNode`
      Get the menu item's label This could either be a string value set directly in the metadata or an EL expression string. In the case of an EL expression, we need to get its bound value.
      Overrides:
        `getLabel` in class `MenuNode`
      Returns:
        label as a String

    - #### getIcon

          public final String getIcon()

      Description copied from class: `MenuNode`
      Get the icon used by the menu item This could either be a string value set directly in the metadata or an EL expression string. In the case of an EL expression, we need to get its bound value.
      Overrides:
        `getIcon` in class `MenuNode`
      Returns:
        icon - the String URI to the icon.

    - #### getChildren

          public final List<MenuNode> getChildren()

      Description copied from class: `MenuNode`
      Get the List of menu item's children.
      Overrides:
        `getChildren` in class `MenuNode`
      Returns:
        List of menu item's children

    - #### setChildren

          public void setChildren(List<MenuNode> children)

      Description copied from class: `MenuNode`
      Set the List of menu item's children.
      Overrides:
        `setChildren` in class `MenuNode`
      Parameters:
        `children` - - List of MenuNode children for this MenuNode

    - #### getFocusViewId

          public final String getFocusViewId()

      Description copied from class: `MenuNode`
      Gets the value of the node's focusViewId property.
      Overrides:
        `getFocusViewId` in class `MenuNode`
      Returns:
        string - the value of the Node's "focusViewId" property.

    - #### getRendered

          public final boolean getRendered()

      Description copied from class: `MenuNode`
      Gets the rendered attribute of the menu item. If false, menu item will not appear.
      Overrides:
        `getRendered` in class `MenuNode`
      Returns:
        boolean indicating whether or not the menu item is visible.

    - #### getDisabled

          public final boolean getDisabled()

      Description copied from class: `MenuNode`
      Gets the disabled attribute of the menu item. If true, menu item will not appear greyed-out and clicking on it will have no effect
      Overrides:
        `getDisabled` in class `MenuNode`
      Returns:
        boolean indicating whether or not the menu item is disabled.

    - #### getVisible

          public final boolean getVisible()

      Description copied from class: `MenuNode`
      Gets the visible attribute of the menu item. If false, menu item will not appear
      Overrides:
        `getVisible` in class `MenuNode`
      Returns:
        boolean indicating whether or not the menu item is visible.

    - #### getReadOnly

          public final boolean getReadOnly()

      Description copied from class: `MenuNode`
      Gets the readOnly state of the node.
      Overrides:
        `getReadOnly` in class `MenuNode`
      Returns:
        the node's readOnly state as a boolean.

    - #### getHandlerId

          protected final String getHandlerId()

      Description copied from class: `MenuNode`
      Set the MenuContentHandlerImpl's id.
      Overrides:
        `getHandlerId` in class `MenuNode`
      Returns:
        String object id of the MenuContentHandlerImpl

    - #### getBundleKey

          public final String getBundleKey()

    - #### getBundleName

          public final String getBundleName()

    - #### getAccessKey

          public final char getAccessKey()

      Description copied from class: `MenuNode`
      getAccessKey - get the label's accessKey as a char.
      Overrides:
        `getAccessKey` in class `MenuNode`
      Returns:
        the access key of the label as a char.

    - #### getLabelAndAccessKey

          public final String getLabelAndAccessKey()

      Description copied from class: `MenuNode`
      getLabelAndAccessKey - get the label and accessKey together in a single string.
      Overrides:
        `getLabelAndAccessKey` in class `MenuNode`
      Returns:
        a String containing (representing) the label and accessKey together.

    - #### getId

          public final String getId()

      Description copied from class: `MenuNode`
      getId - gets the metadata id of the node.
      Overrides:
        `getId` in class `MenuNode`
      Returns:
        - String identifier for the node component.

    - #### getModelId

          public final String getModelId()

      Description copied from class: `MenuNode`
      Gets the local (shared node's) menu Model's Request map key.
      Overrides:
        `getModelId` in class `MenuNode`

    - #### getUniqueId

          public final String getUniqueId()

      Description copied from class: `MenuNode`
      getUniqueId - gets the unique id of the node.
      Overrides:
        `getUniqueId` in class `MenuNode`
      Returns:
        - String identifier for the node component.

    - #### getDefaultFocusPath

          public final boolean getDefaultFocusPath()

      Description copied from class: `MenuNode`
      Gets the defaultFocusPath attribute of the menu item.
      Overrides:
        `getDefaultFocusPath` in class `MenuNode`
      Returns:
        boolean indicating whether or not this is the focus path to use, by default, in cases where there are duplicate paths to this node and the focus path is not determinable by the XMLMenuModel model.

    - #### getRootModelKey

          public final String getRootModelKey()

      Description copied from class: `MenuNode`
      Get the top-level, root menu model Request Map Key.
      Overrides:
        `getRootModelKey` in class `MenuNode`
      Returns:
        root, top-level XMLMenuModel's Request Map Key.

    - #### getRootId

          public final int getRootId()

      Overrides:
        `getRootId` in class `MenuNode`

Copyright © 2001-2017 The Apache Software Foundation. All Rights Reserved.